#include "proxy.h"

Response *upstreamGetResponse(Request *request){
	//Here we pretend to be a client

	int client_fd = 0;
	struct sockaddr_in address;
	memset( &address, 0, sizeof(address) );
	struct hostent *host = gethostbyname(request->host);
	Response *rsp = NULL;

	if ((client_fd = socket(AF_INET, SOCK_STREAM, 0)) == 0){
		perror("socket failed");
		return NULL;
	}


	address.sin_family = AF_INET;
	address.sin_port = htons( 80 );
	// We want the request to go out to whatever the host was resolved to
	memcpy( &address.sin_addr, host->h_addr_list[0], host->h_length );

	if((connect(client_fd, (struct sockaddr *)&address, sizeof(address)))<0)  {  
		perror("connect failed");
		return NULL;
	}

	char *toSend = requestToString(request);

	if ( write( client_fd, toSend, strlen(toSend) ) != strlen(toSend) ){
		perror( "Write Error" );
		return NULL;
	}

	rsp = newResponseFromSocket( client_fd );

	return rsp;

}

int proxy_startListener(unsigned int port){
	//we need to act as an http server
	int server_fd;
    struct sockaddr_in address;
	memset( &address, 0, sizeof(address) );
    int addrlen = sizeof(address);
	Response *response;
	char *responseStr;

    // Creating socket file descriptor
    if ((server_fd = socket(AF_INET, SOCK_STREAM, 0)) == 0) {
        perror("socket failed");
		return -1;
    }

    address.sin_family = AF_INET;
    address.sin_addr.s_addr = INADDR_ANY;
    address.sin_port = htons( port );

    // Forcefully attaching socket to the port 8080
    if (bind(server_fd, (struct sockaddr *)&address, sizeof(address)) != 0) {
        perror("bind failed");
		return -1;
    }

    if (listen(server_fd, 3) != 0) {
        perror("listen");
		return -1;
    }

	return server_fd;


}
